#!/usr/bin/env bash

set -xu

# Generated by:
# ruby -e 'puts $<.readlines.map{ |x| x.split(/=/,2).shift}.map{ |x| "#{x}=\"#{x}\""}' run/variables.sh
# This was the "safer" version
# ruby -e 'puts $<.readlines.map{ |x| x.split(/=/,2).shift}.map{ |x| "#{x}=\"\\${#{x}:-${#{x}}}\""}' run/variables.sh

my_dir="$(cd "$(dirname "${BASH_SOURCE[0]}")" >/dev/null 2>&1 && pwd)"
. ${my_dir}/variables.sh

cat <<EO_ENV_VARS | tee "${output_dir}/variables.sh"
alpine_arch="${alpine_arch}"
alpine_dl_type="${alpine_dl_type}"
alpine_patch="${alpine_patch}"
alpine_type="${alpine_type}"
alpine_version="${alpine_version}"
boot_wait="${boot_wait}"
cpus="${cpus}"
dir="${dir}"
disk_format="${disk_format}"
disk_size="${disk_size}"
dns_server="${dns_server}"
domain="${domain}"
iso_checksum="${iso_checksum}"
iso_checksum_type="${iso_checksum_type}"
iso_name="${iso_name}"
iso_url="${iso_url}"
mem="${mem}"
output_variables="${output_variables}"
shasum_url="${shasum_url}"
ssh_key_file="${ssh_key_file}"
ssh_password="${ssh_password}"
ssh_username="${ssh_username}"
timestamp="${timestamp}"
variables="${variables}"
vm_name="${vm_name}"
ssh_public_key="${ssh_public_key}"
EO_ENV_VARS

exit 0

# This doesn't work in GitLab for some reason...  as much as I hate to, just brute force our variables for now...

# set -o posix apparently dumps all vars
initial_vars="$(
    set -o posix
    set
)"

# source our variables script
. ${my_dir}/variables.sh

# parse our initial vars out
script_vars="$(grep -vFe "${initial_vars}" <<<"$(
    set -o posix
    set
)" | grep -v ^initial_vars=)"

unset initial_vars

# dump our vars to our file
mkdir -vp "${output_dir}"
echo "${script_vars}" | tee "${output_dir}/variables.sh"
# For some reason this doesn't count... is it not posix complaint?
echo "ssh_public_key=${ssh_public_key}" | tee -a "${output_dir}/variables.sh"

# remove shasum_file as it isn't a proper json string and isn't particularly useful anyway
sed -i '/shasum_file/d' "${output_dir}/variables.sh"

# This all is fairly fragile...  could use some work.
